#include "stdafx.h"
#include "manager.h"
#include "interfaces.h"

/* 
 *	Zde musi byt vlozeny vsechny tridy ktere maji interface
 */
#include "spaceship.h"
#include "unique.h"

/*
 *	Implementace funkce CreateObject()
 */

HRESULT	CreateObject(EXIID InterfaceID, void ** ppv)
{
	/* ukazatele unikatnich objektu se v prubehu programu nemeni */
	static IUnique		* g_theUnique = NULL;	
	if(!ppv)
	{
		return -1;
	}
	/* vrati spravny ukazatel podle ID rozhrani */
	switch(InterfaceID) {
		case EXIID_IUnique:
			if(!g_theUnique) 
			{
				*ppv = g_theUnique = new CUnique;
			}
			else {
				*ppv = g_theUnique;
			}
			((IUnique*)(*ppv))->AddRef();
			break;		
		case EXIID_ISpaceship:				
			*ppv = new CSpaceship;			
			((CSpaceship*)(*ppv))->AddRef();
			break;		
		default:
			return -2;
	}
	return 0;
}
