#pragma once

typedef	unsigned long HRESULT;
/*
 *	Rozhrani tridy CSpaceship
 *  Tato trida musi byt od odvozena od ISpaceship a tak
 *	implementuje metody rozhrani
 *
 *	Rozhrani neobsahuje atributy, ale pouze ciste virtualni metody
 *	tim padem, tyto metody MUSI byt implementovany ve tride CSpaceship
 */
class	ISpaceship
{
public:
	/* priklad metody rozhrani */
	virtual void Init(int position) = 0;
	virtual void Move(int direction) = 0;
	virtual void Display() = 0;

public:	
	/* povinne dve metody rozhrani */
	virtual HRESULT		AddRef() = 0;
	virtual HRESULT		Release() = 0;
};

/*
 *	Druhe ukazkove rozhrani predstavuje rozhrani
 *	unikatniho objektu. Trida CUnique je odvozena
 *	od tohoto rozhrani
 */
class	IUnique
{
public:
	virtual	void Start(char * message) = 0;
	virtual	void Message() = 0;

public:	
	/* povinne dve metody rozhrani */
	virtual HRESULT		AddRef() = 0;
	virtual HRESULT		Release() = 0;
};
